#include <stdio.h>
#include <stdlib.h>
#include <curses.h>
#include <unistd.h>
#include <malloc.h>
/***********************************************************************
Unix setext viewer 

Developed by O. Isikli and A. Eyler of Bilkent University, Ankara, TURKEY

Version 0.2 -- June 93
Version 0.1 -- May 93
***********************************************************************/
#include <string.h>
#include <signal.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <memory.h>
#include "sv.h"

void load_file(handle)
int handle;
{
long int cnt;
char line[200];
int h;

if (handle==0)
	{
	char line[200];

	cnt=0;
	buf=malloc(2000000);
	while(fgets(line,200,stdin)!=NULL)
		{
		memcpy(buf+cnt,line,strlen(line));
		cnt+=strlen(line);
		}
	size=cnt;
	ptr=0;
	ctermid(line);
	h=open(line,0);
	stdin->_file=h;
	stdin->_flag=h;
	}
else
	{
	size=lseek(handle,0L,SEEK_END);
	lseek(handle,0L,SEEK_SET);
	buf=malloc(size+10000);
	read(handle,buf,size);
	close(handle);
	ptr=0;
	}
}

void display_chapters(offset)
int offset;
{
register int cnt,cnt2;
char tmp[10],line[50];
char *empty;

empty=malloc(winx-7);
memset(empty,32,winx-7);

for (cnt=offset ; (cnt<chaptercount && cnt <((winy-6)+offset) ); ++cnt )
	{
	move((cnt-offset)+3,0);
	addstr(empty);
	move((cnt-offset)+3,6);
	sprintf(tmp,"%d.",cnt+1);
	sprintf(line,"%-4s %s",tmp,Chapters[cnt].name);
	addstr(line);
	clrtoeol();
	}
for (cnt2=cnt ; cnt2<((winy-6)+offset) ; ++cnt2)
	{
	move((cnt2-offset)+3,0);
	addstr(empty);
	}
refresh();
}

void AddChapter(name,pos)
char *name;
long int pos;
{
nochap=1;
Chapters[chaptercount].name=malloc(strlen(name));
strcpy(Chapters[chaptercount].name,name);
Chapters[chaptercount].first=sectioncount;
Chapters[chaptercount].seccount=0;
chaptercount++;
AddSection(name,pos);
}

void AddSection(name,pos)
char *name;
long int pos;
{
Sections[sectioncount].name=malloc(strlen(name));
strcpy(Sections[sectioncount].name,name);
Sections[sectioncount].start=pos;
if (sectioncount)
	Sections[sectioncount-1].length=pos-Sections[sectioncount-1].start;
sectioncount++;
Chapters[chaptercount-1].seccount+=1;
}

char* readline()
{
static char line[1000];
int len,done;
char ch;

len=0;
done=0;
if (ptr==size)
	return(0L);
ch=*(buf+(ptr++));
while (ch!=LF)
	{
	line[len++]=ch;
  	if (ptr==size)
		return(0);	
	ch=*(buf+(ptr++));
	}
len--;
while ( (len>0) && ( (line[len]==SPACE) || (line[len]==TAB) ) )
	len--;
line[len+1]=0;
return(line);
}

char linekind(l)
char* l;
{
char ch;
register int cnt=1;

if (strcmp(l,"..")==0)
	return(ENDLINE);
ch=l[0];
while (cnt<strlen(l))
	if (l[cnt++]!=ch)
		break;
if (cnt==strlen(l))
	{
	if (ch=='-')
		return(HYPHENLINE);
	else if (ch=='=')
		return(EQUALLINE);
	}
return(0);
}

int parse()
{
char *line,*prevline;
long int pos,prevpos;
int len,prevlen;
int done;
char ch;


prevline=malloc(1000);
pos=0L;
line=readline();
len=strlen(line);
done=0;
while (!done)
	{
	prevpos=pos;
	prevlen=len;
	strcpy(prevline,line);
	pos=ptr;
	if ( (line=readline())==0L)
		done=1;
	else
		{
		ch=linekind(line);
		len=strlen(line);
		if ( (ch==EQUALLINE) && (len==prevlen) )
			AddChapter(prevline,prevpos);
		else if ( (ch==HYPHENLINE) && (len==prevlen) ) 
			if (nochap==0)
				AddChapter(prevline,prevpos);
			else
				AddSection(prevline,prevpos);
		else if (ch==ENDLINE)
			done=1;
		}
	}
	Sections[sectioncount-1].length=pos-Sections[sectioncount-1].start;


}

int chapters_menu()
{

register int cnt;
char ok;
int inp;
char fname[100],com[100];
char *pointer="-->";
char *empty="    ";
char *mes="<UP> and <DOWN> to move, <CR> for sections, <Q> to quit";

ok=0;
clear();
display_chapters(cscroff);

move(3+cpline-cscroff,2);
addstr(pointer);
move(winy-1,1);
addstr(mes);
move(3+cpline-cscroff,5);
refresh();
while (!ok)
	{
	refresh();
	inp=getch();
	switch(inp)
		{
		case 'Q' :    
		case 'q' :	return(EXIT);
				break;
		case '>'   :
		case ' '   :
		case KEY_C3   :
		case KEY_NPAGE:
		case '3'  :
			 	move(3+cpline-cscroff,2);
				addstr(empty);	
				if ((cscroff+winy-6)<=chaptercount)
					{
					cpline+=(winy-6);
					if (cpline>(chaptercount-1))
						cpline=chaptercount-1;					
					cscroff+=(winy-6);
					display_chapters(cscroff);
					}	
			   	move(3+cpline-cscroff,2);
				addstr(pointer);
				refresh();				
				break;
		case 'H' :
		case 'h' :
		case '?' :  
				sprintf(fname,"/tmp/sv%d.%d",getpid(),getuid());
				scr_dump(fname);
				helpwiever();
				scr_restore(fname);
				refresh();
				sprintf(com,"rm %s",fname); system(com);
				break;
		case '<'       :
		case 'B'       :
		case KEY_A3     :
		case  KEY_PPAGE :
		case '9' :
		case 'b':	if (cscroff>0)
					{
					cpline-=(winy-6);
					if (cpline<0) cpline=0;
					cscroff-=(winy-6);
					if (cscroff<0) cscroff=0;
					display_chapters(cscroff);
					}
				move(3+cpline-cscroff,2);
				addstr(pointer);
				refresh();
				break;
		case 'n'      :
		case 'N'      :
		case KEY_BTAB :
		case '2':
		case KEY_DOWN : 
                                move(3+cpline-cscroff,2);
				addstr(empty);
				cpline=(cpline+1)%chaptercount;
				if (cpline>=((winy-6)+cscroff))
					{
					cscroff+=(winy-6);
					display_chapters(cscroff);
					}
				else if (cpline==0)
					{
					cscroff=0;
					display_chapters(cscroff);
					}
			   	move(3+cpline-cscroff,2);
				addstr(pointer);
				refresh();
				break;
		case 'p' :
		case 'P' :
		case '8' :
		case KEY_UP :   move(3+cpline-cscroff,2);
				addstr(empty);
				cpline--;
				if (cpline==-1)
					{
					cpline=chaptercount-1;
					while ((cscroff+winy-6)<chaptercount)
						cscroff+=(winy-6);
					display_chapters(cscroff);
					}
				else if (cpline<cscroff)
					{
					cscroff-=(winy-6);
					display_chapters(cscroff);
					}
			   	move(3+cpline-cscroff,2);
				addstr(pointer);
				refresh();
				break;
		case 13	       :
		case '6'	:
		case KEY_RIGHT :
		case KEY_ENTER :return(cpline);
				break;
                default:        
                                break;
		}
	}
}

fill_previous_line(cup,counter,start,line)
char *cup;
int *counter;
int start,line;
{
    int i=0,pastline=0,count;

    count=*counter;
    count--;
    if(line==(winy-1)) 
    {
       (*counter)-=2;     
       while((buf[start+(*counter)]!='\n') && (counter >= 0))
         (*counter)--;
       (*counter)++;  
    }  			  
  
    while((pastline <= (line+1)) && (count >0))
    {   if(buf[start+count] != '\n')
           count--;
        else 
        {  count--; pastline++; }
    }
    count+=2;
    i=0;
    while(buf[start+count]!='\n')
    {   cup[i]=buf[start+count]; i++; count++; }  

    cup[i]='\n';
    cup[i+1]='\0';

}

int pager(chap,sec)
int chap,sec;
{
chtype sch;
int tmp,mode,modecup,counte,i,length,start;
char *command,com[50],*sname,cup[500],format[20];
int ch,next=0,cnt,y,x,chr,a,b;
int line,counter,linecounter,visline,totallines;
char fname[100];
char *mes=" Use keypad to move, <LEFT> for sections";
WINDOW *outwin;


if(chap!=-1)
{   length=Sections[(Chapters[chap].first)+sec].length;
    start=Sections[(Chapters[chap].first)+sec].start;  }
else
{   start=sec;
    length=strlen(buf)-start;    }

outwin=newwin(0,0,0,0);
scrollok(outwin,TRUE); 
idlok(outwin,TRUE);
keypad(outwin,TRUE);
wrefresh(outwin);


totallines=0;
for(i=0; i<length; i++)
  if(buf[start+i]=='\n') totallines++; 

sprintf(format,"%%.%ds",winx);
nonl();
line=0;
counter=0;
visline=0;

while(1)
{       
    i=0;
    while((buf[start+counter]!='\n') && (counter <= length))
    {   cup[i]=buf[start+counter]; i++; counter++; }

    cup[i]='\n';
    cup[i+1]='\0';
    wprintw(outwin,format,cup);
    line++;
    visline++; 
    visline=visline%(winy);
    
    wrefresh(outwin);
    counter++; 
    i++;

    if(line==totallines)
    {  
ENDDOC:  
       wmove(outwin,winy-1,0);  
       wattron(outwin,A_REVERSE);
       wprintw(outwin,"(100%%)");
       wattroff(outwin,A_REVERSE);
       wprintw(outwin,"%s",mes);
       wrefresh(outwin);       
       
       goto ENDPAGE;
    }
    if((visline%(winy-1))==0)
    {  
       wattron(outwin,A_REVERSE);
       wprintw(outwin,"(%d%%)",(counter*100)/length); wattroff(outwin,A_REVERSE);
       wprintw(outwin,"%s",mes);
       wrefresh(outwin);
       
ENDPAGE:
       ch=0;
       while(ch!=1)
       {   wrefresh(outwin); 
       ch=getch();
       switch(ch)
       {
	   case 'Q'          :		     
           case 'q'          : wattroff(outwin,A_REVERSE); wrefresh(outwin); wmove(outwin,winy-1,0);
				wclrtoeol(outwin); wrefresh(outwin); endwin(); exit(0);
	   case 'U'     :
	   case 'u'     :
	   case '4'	     :
           case KEY_LEFT     : goto PREV_SCREEN;

           case '7'          :
	   case KEY_A1	     :
           case KEY_HOME     :  line=0;
				counter=0;
				visline=0;
				wclear(outwin); wrefresh(outwin); ch=1;
				break;

           case '1'          :
	   case KEY_END      :
	   case KEY_C1       :  
				line=totallines+1;
				counter=length+1;
				visline=(winy-1);

				linecounter=0;  counter--; 
				while( (line > 0) && (linecounter < (winy)) )
				{  counter--;
				   while((buf[start+counter]!='\n') && (counter >= 0))
					counter--;
				   linecounter++; line--;
				}
				counter++;  
				wclear(outwin); wrefresh(outwin); ch=1; visline=0; 
				break;

	   case '8'	     :			
           case KEY_UP       : if((line-(winy-1)) > 0)
                               {   
				   
				   fill_previous_line(cup,&counter,start,visline);				   

 				   wmove(outwin,0,0);

				   if(visline==(winy-1))  line--;

				   winsertln(outwin);
				   wmove(outwin,0,0);
				   wprintw(outwin,format,cup);
				   wmove(outwin,winy-1,0);
				   wclrtoeol(outwin);
				   wrefresh(outwin);

				   if(visline < (winy-1))  visline++;

				   wattron(outwin,A_REVERSE);
				   wmove(outwin,winy-1,0);
				   wprintw(outwin,"(%d%%)",(counter*100)/length);
				   wattroff(outwin,A_REVERSE);
				   wprintw(outwin,"%s",mes);
				   wrefresh(outwin);
				   
				   
			       }
			       wrefresh(outwin);
                               break;   
	   case '2'	     :
           case KEY_DOWN     :  if(counter < length)
				{  
    				    i=0;
   				    while(buf[start+counter]!='\n')
   				    {   cup[i]=buf[start+counter]; i++; counter++; }

    				    cup[i]='\n';
    				    cup[i+1]='\0';
				    wmove(outwin,winy-1,0);
    				    wprintw(outwin,format,cup); 
				    wrefresh(outwin);  
				    counter++; 
				    line++;
				    wmove(outwin,winy-1,0);
				    wattron(outwin,A_REVERSE);
				    wprintw(outwin,"(%d%%)",(counter*100)/length);
				    wattroff(outwin,A_REVERSE);
				    wprintw(outwin,"%s",mes);
      				    wrefresh(outwin);
				    wattroff(outwin,A_REVERSE);
				    
				    
 				}
				else  goto ENDDOC;
				    			
				break;
	   case '>'	     :
	   case 13           :
	   case '3'	     :
	   case KEY_NPAGE    :
	   case KEY_C3       :
	   case ' '	     :  if(line==totallines) {  next=1; goto PREV_SCREEN;  }
				else {
				   wclear(outwin); wrefresh(outwin); ch=1; visline=0;  }
				break;
	   case '<'          :
	   case 'B'          :
	   case 'b'          :
	   case KEY_A3       :
	   case '9'          :
           case KEY_PPAGE    :  
				linecounter=0;  counter--; 
				while( (line > 0) && (linecounter < ((winy-1)+visline)) )
				{  counter--;
				   while((buf[start+counter]!='\n') && (counter >=0))
					counter--;
				   linecounter++; line--;
				}
				counter++;  
				wclear(outwin); wrefresh(outwin); ch=1; visline=0; 
				break;
		    case 'P' :
		    case 'p' : 	wmove(outwin,winy-1,0);
				wclrtoeol(outwin);
				wprintw(outwin,"Press y to confirm printing!");
				wrefresh(outwin);
				chr=wgetch(outwin);
				if((chr=='y') || (chr=='Y'))
			        {  
				   sprintf(fname,"/tmp/sv%d.%d",getpid(),getuid());
				   tmp=creat(fname,0600);
				   ptr=Sections[(Chapters[chap].first)+sec].start;
				   write(tmp,buf+ptr,Sections[(Chapters[chap].first)+sec].length);
				   close(tmp);
				   sprintf(com,"lpr %s",fname);
				   system(com);
				   sprintf(com,"rm %s",fname); system(com);
				}
				if(line==totallines)  goto ENDDOC;  
				else {  wattron(outwin,A_REVERSE);  wmove(outwin,winy-1,0);
					wclrtoeol(outwin);
					wprintw(outwin,"(%d%%)",(counter*100)/length);
					wattroff(outwin,A_REVERSE);
					wprintw(outwin,"%s",mes);
					wrefresh(outwin);
			    	     }
				 
				break;
		    case '?' :
		    case 'H' :
		    case 'h' :  sprintf(fname,"/tmp/sv%d.%d",getpid(),getuid());
				scr_dump(fname);
				helpwiever();
				scr_restore(fname);
				wrefresh(outwin);
				sprintf(com,"rm %s",fname); system(com);
				break;
		    case 'S' :
	            case 's' :	wmove(outwin,winy-1,0);
				wclrtoeol(outwin);
				sname=malloc(100);
				wprintw(outwin,"Filename to save: ");
				nonl();
				wrefresh(outwin);
				
				chr=0; x=0; 
				while(chr!=13)  
				{ 
				  chr=wgetch(outwin); 
				  if(chr!=' ')
				  {  if((chr==8) || (chr==127) || (chr==KEY_DC) || (chr==KEY_BACKSPACE) ) 
				     {   
					 if(x > 0)  {
					 getyx(outwin,a,b);
					 wmove(outwin,a,b-1);
					 wclrtoeol(outwin);
					 wrefresh(outwin);
					 x--;  }
				     }
				     else
				     {   wprintw(outwin,"%c",chr); 
					 sname[x++]=chr;
				     }
				  }
				}
				sname[--x]='\0';

				for (cnt=0 ; cnt<strlen(sname) ; ++cnt)
					if (*(sname+cnt)!=32) break;
				if (cnt!=strlen(sname))
				{
				  mode=umask(18);
				  modecup=umask(mode);
				  tmp=open(sname,O_WRONLY | O_CREAT | O_APPEND,mode^0666);
				  ptr=Sections[(Chapters[chap].first)+sec].start;
				  write(tmp,buf+ptr,Sections[(Chapters[chap].first)+sec].length);
				  close(tmp);
				}
				else
				wprintw(outwin,"....Invalid filename. Save failed");
				if(line==totallines)  goto ENDDOC; 
				else {  wattron(outwin,A_REVERSE);  wmove(outwin,winy-1,0);
					wclrtoeol(outwin);
					wprintw(outwin,"(%d%%)",(counter*100)/length);
					wattroff(outwin,A_REVERSE);
					wprintw(outwin,"%s",mes);
					wrefresh(outwin);
			    	    	  }
				break;
				   
        }
      }
    }
}

 
PREV_SCREEN:
 
wclear(outwin);
wrefresh(outwin); 
system("clear"); 
if (next)
	return(NEXTSECT);
}

void display_sections(chap,offset)
int offset;
{
register int cnt,cnt2;
char tmp[10],line[50];
char *empty;

for (cnt=offset ; (cnt<Chapters[chap].seccount && cnt <((winy-6)+offset) ); 
						++cnt )
	{
	move((cnt-offset)+3,6);
	sprintf(tmp,"%d.",cnt);
	sprintf(line,"%-4s %s",tmp,Sections[Chapters[chap].first+cnt].name);
	addstr(line);
	clrtoeol();
	}
empty=malloc(winx-7);
memset(empty,32,winx-7);
for (cnt2=cnt ; cnt2<((winy-6)+offset) ; ++cnt2)
	{
	move((cnt2-offset)+3,6);
	addstr(empty);
	}
refresh();
}

int sections_menu(chap)
int chap;
{
register int cnt;
char ok;
int inp;
char fname[100],com[100];
char *pointer="-->";
char *empty="    ";
char *mes="<UP> and <DOWN> to move, <LEFT> for chapters, <CR> to view";
char line[50];
int sc,tmp;

ok=0;
clear();
display_sections(chap,sscroff);
sc=Chapters[chap].seccount;

spline=0;

move(winy-1,1);
addstr(mes); 
refresh();


move(3+spline,2);
addstr(pointer);
refresh();
while (!ok)
	{
	refresh();
	inp=wgetch(stdscr);
	switch (inp)
		{
		case 'Q' :
		case 'q': 	return(EXIT);	
				break;
		case '>'  :
		case ' '  :
		case KEY_NPAGE:
		case KEY_C3   :
		case '3'      : move(3+spline-sscroff,2);
				addstr(empty);	
				if ((sscroff+winy-6)<=sc)
					{
					spline+=(winy-6);
					if (spline>(sc-1))
						spline=sc-1;					
					sscroff+=(winy-6);
					display_sections(chap,sscroff);
					}	
			   	move(3+spline-sscroff,2);
				addstr(pointer);
				refresh();				
				break;
		case 'b'  :
		case 'B'  :
		case '<'  :
		case KEY_PPAGE:
		case KEY_A3:
		case '9':	if (sscroff>0)
					{
					spline-=(winy-6);
					if (spline<0) spline=0;
					sscroff-=(winy-6);
					if (sscroff<0) sscroff=0;
					display_sections(chap,sscroff);
					}
				move(3+spline-sscroff,2);
				addstr(pointer);
				refresh();
				break;
		case '4'     :
		case KEY_LEFT:
		case 'U' :
		case 'u':	
				return(UPMENU);
				break;
		case 'n'  :
		case 'N'  :
		case KEY_BTAB :
		case '2':
		case KEY_DOWN:	move(3+spline-sscroff,2);
				addstr(empty);
				spline=(spline+1)%sc;
				if (spline>=((winy-6)+sscroff))
					{
					sscroff+=(winy-6);
					display_sections(chap,sscroff);
					}
				else if (spline==0)
					{
					sscroff=0;
					display_sections(chap,sscroff);
					}
	   			move(3+spline-sscroff,2);
				addstr(pointer);
				refresh();
				break;
		case 'H' :
		case 'h' :
		case '?' :
				sprintf(fname,"/tmp/sv%d.%d",getpid(),getuid());
				scr_dump(fname);
				helpwiever(); 
				scr_restore(fname);
				refresh();
				sprintf(com,"rm %s",fname); system(com);
				break;
		case 'p'  :
		case 'P'  :
		case '8':
		case KEY_UP:
				move(3+spline-sscroff,2);
				addstr(empty);
				spline--;

				if (spline==-1)
					{
					spline=sc-1;
					while ((sscroff+winy-6)<sc)
						sscroff+=(winy-6);
					display_sections(chap,sscroff);
					}
				else if (spline<sscroff)
					{
					sscroff-=(winy-6);
					display_sections(chap,sscroff);
					}

				move(3+spline-sscroff,2);
				addstr(pointer);		
				refresh();	
				break;
		case 13:
		case KEY_RIGHT:
		case '6'  :
		case KEY_ENTER: tmp=3+spline-sscroff;
				while (pager(chap,spline)==NEXTSECT)
					{  
					spline=(spline+1)%sc;
					if (spline>=((winy-6)+sscroff))
						sscroff+=(winy-6);
					else if (spline==0)
						sscroff=0;
					}
				display_sections(chap,sscroff);
				move(winy-1,1);
				addstr(mes);
				move(tmp,2);
				addstr(empty);
				move(3+spline-sscroff,2);
				addstr(pointer);
				refresh();nonl();			
				break;
               default:        
                                break;
		}
	}
}


int main(argc,argv,envp)
int argc;
char *argv[];
char **envp; 
{
int res,handle,i,y,x;
char com[10];

dirpager=chaptercount=sectioncount=0;
cpline=spline=sscroff=cscroff=0;
if (argc==2 || argc==1)
	{
	char newname[60];

        if(argc==2)
	{  strcpy(newname,argv[1]);
           handle=open(newname,0);
        }
        else
        {  strcpy(newname,"stdin");
           handle=0;
        }
         
	if (handle==-1)
		{		
		strcat(newname,".etx");
		handle=open(newname,4);
		if (handle==-1)
			{
			printf("File not found\n");
			exit(0);
			}
		}
	load_file(handle);

        parse();
	if(chaptercount==0)
		{
		    AddSection(newname,0);
		    /* handle=open(newname,0);
		    Sections[0].length=lseek(handle,0L,SEEK_END);
		    lseek(handle,0L,SEEK_SET);
		    close(handle); */
		    Sections[0].length=strlen(buf);
		    dirpager=1;
		}
	}
else if (argc==3)
	{
	handle=open(argv[2],4);
	if (handle==-1)
		{
		char newname[60];

                strcpy(newname,argv[2]);
                strcat(newname,".etx");
                handle=open(newname,4);
                if (handle==-1)
                        {
			printf("File not found\n");
			exit(0);
			}
		}
 
	load_file(handle);
	parse();
	if(chaptercount==0)
		{
		AddChapter(argv[2],0);
		handle=open(argv[2],4);
		Sections[0].length=lseek(handle,0L,SEEK_END);
		lseek(handle,0L,SEEK_SET);
		close(handle);
		dirpager=1;
		}      
	}
system("clear");
initscr();

cbreak();
noecho();
nonl();


intrflush(stdscr,FALSE);
keypad(stdscr,TRUE);
refresh();


winy=getmaxy(stdscr);
winx=getmaxx(stdscr);

signal(SIGTSTP,before_suspend);
fillhelp();

if (dirpager)
	pager(0,0);
else
	{ 
	res=chapters_menu();
	while (res!=EXIT)
		{
		res=sections_menu(res);
		if (res==UPMENU)  
			res=chapters_menu(); 
		}
	}
move(winy-1,0);
refresh();
clrtoeol();
refresh();
endwin();
}
before_suspend()
{

  endwin();

  kill(0,SIGTSTP);
  signal(SIGTSTP,before_suspend);


}

fillhelp()
{
  int handle,size;

  helpstart=strlen(buf);
  help="KEY             LIST MODE       TEXT MODE
----------      -----------     -----------
8 <UP>          Prev item       Scroll up
2 <DOWN>        Next item       Scroll down
4 <LEFT>        Upper level     List mode
6 <RIGHT>       Select item     (N/A)
9 <PgUp>        Prev page       Prev page
3 <PgDn>        Next page       Next page
7 <HOME>        (N/A)           First page
1 <END>         (N/A)           Last page
  <CR>          Select item     Next page
  P             Prev item       Print text
  N             Next item       (N/A)
< B             Prev page       Prev page
> <SPACE>       Next page       Next page
  U             Upper level     List mode
  S             (N/A)           Save text
? H             Help            Help
  Q		Quit		Quit


Keys are not case-sensitive
";
  size=strlen(help);
  bcopy(help,buf+helpstart,size);

/*  handle=open("sv.help",0);
  size=lseek(handle,0L,SEEK_END);
  lseek(handle,0L,SEEK_SET);

  read(handle,buf+helpstart,size);
*/
}
int helpwiever()
{
int length,start,chr,i;
char format[100], cup[500];
int line,counter,linecounter,visline,totallines;
WINDOW *outwin;


start=helpstart;
length=strlen(buf)-start;   

outwin=newwin(0,0,0,0);
scrollok(outwin,TRUE); 
idlok(outwin,TRUE);
wrefresh(outwin);

totallines=0;
for(i=0; i<length; i++)
  if(buf[start+i]=='\n') totallines++; 

sprintf(format,"%%.%ds",winx);
nonl();
line=0;
counter=0;
visline=0;

while(1)
{       
    i=0;
    while((buf[start+counter]!='\n') && (counter <= length))
    {   cup[i]=buf[start+counter]; i++; counter++; }

    cup[i]='\n';
    cup[i+1]='\0';
    wprintw(outwin,format,cup);
    line++;
    visline++; 
    visline=visline%(winy);
    
    wrefresh(outwin);
    counter++; 
    i++;

    if(line==totallines)
    {  
       wmove(outwin,winy-1,0);  
       wprintw(outwin,"Any key to return");
       wrefresh(outwin);
       chr=wgetch(outwin);
       while(chr==-1) { wrefresh(outwin);  chr=wgetch(outwin);  }
       
       goto PREV_SCREEN;
    }

    if((visline%(winy-1))==0)
    {  
       wmove(outwin,winy-1,0);
       wprintw(outwin,"<SPACE> to continue any key to return");
       wrefresh(outwin);
       
    
       chr=getch(); 
       while(chr==-1) { wrefresh(outwin);  chr=wgetch(outwin);  }
       switch(chr)
       {
            case ' ' :  wclear(outwin); wrefresh(outwin); visline=0; break;
	    default  :  goto PREV_SCREEN; break;
       }  
    }
}
PREV_SCREEN:
wclear(outwin);
wrefresh(outwin); 
system("clear"); 
}




